package com.docus.sw.souyin;


import com.alibaba.excel.EasyExcel;
import com.itextpdf.text.Font;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;
import org.apache.poi.ss.usermodel.*;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * @author 未来码匠
 */
public class ExcelUtil {
    public static void easyExcelTest() throws Exception {

        String fileName = "C:\\jiahsi-saomiao\\缩微\\test\\test.xls";
        //查询出导出的数据
        List<MesEasyExcel> mesEasyExcels = getData();
        try {
            EasyExcel.write(fileName, MesEasyExcel.class).sheet("test").doWrite(mesEasyExcels);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        ExcelUtil.toPdf(fileName,"C:\\jiahsi-saomiao\\缩微\\test\\output.pdf");


    }



    public static void toPdf(String filename,String outName){
        try (Workbook workbook = WorkbookFactory.create(new File(filename));
             FileOutputStream fos = new FileOutputStream(outName)) {
            // 获取第一个工作表
            Sheet sheet = workbook.getSheetAt(0);

            // 创建PDF文档对象
            Document document = new Document(PageSize.A4, 50, 50, 50, 50);

            // 创建PDF输出流
            PdfWriter writer = PdfWriter.getInstance(document, fos);

            // 打开PDF文档
            document.open();

            // 创建PDF表格对象
            PdfPTable table = new PdfPTable(sheet.getRow(0).getLastCellNum());

            // 设置表格宽度
            table.setWidthPercentage(100);

            // 设置表格标题
            com.itextpdf.text.Font font = FontFactory.getFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED,10f, com.itextpdf.text.Font.NORMAL, BaseColor.BLACK);
            Paragraph title = new Paragraph("",font);
            title.setAlignment(Element.ALIGN_CENTER);
            document.add(title);

            // 添加表格内容
            for (Row row : sheet) {
                for (Cell cell : row) {

                    int columnIndex = cell.getColumnIndex();

                    if(columnIndex==4&&row.getRowNum()!=0){
                        PdfPCell pdfCell = new PdfPCell(new Paragraph(String.valueOf((int)cell.getNumericCellValue()), new Font(BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED), 12)));
                        pdfCell.setBorderWidth(1f);
                        pdfCell.setHorizontalAlignment(Element.ALIGN_CENTER);
                        pdfCell.setVerticalAlignment(Element.ALIGN_MIDDLE);
                        table.addCell(pdfCell);
                    }else{
                        PdfPCell pdfCell = new PdfPCell(new Paragraph(cell.getStringCellValue(), new Font(BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED), 12)));
                        pdfCell.setBorderWidth(1f);
                        pdfCell.setHorizontalAlignment(Element.ALIGN_CENTER);
                        pdfCell.setVerticalAlignment(Element.ALIGN_MIDDLE);
                        table.addCell(pdfCell);
                    }

                }
            }

            // 添加表格到PDF文档
            document.add(table);

            // 关闭PDF文档
            document.close();
            writer.close();
        } catch (IOException | DocumentException e) {
            e.printStackTrace();
        }
    }

    private static List<MesEasyExcel> getData() throws Exception {
        List<MesEasyExcel> list = new ArrayList<MesEasyExcel>();

        for (int i = 0; i < 100; i++) {
            MesEasyExcel m = new MesEasyExcel();
            m.setZongName("全宗名" + i);
            m.setPlateName("盘2");
            m.setRollName("卷名");
            m.setPieces("档号");
            m.setNums(80);
            m.setStartNum("28");
            list.add(m);
        }


        return list;
    }


    public static void main(String[] args) throws Exception {
        ExcelUtil.easyExcelTest();
    }

}
